﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using RGiesecke.DllExport;

namespace InQuikModule
{
    public static class StartupDLL
    {

        public static void CreateDataSourceTick(IntPtr luaState)
        {
            Lua.lua_getfield(luaState, -10002, "CreateDataSource");
            Lua.lua_pushstring(luaState, "SPBFUT");
            Lua.lua_pushstring(luaState, "SiH6");
            Lua.lua_pushnumber(luaState, 0); // tick
            
            Lua.lua_call(luaState, 3, 2);
            int r = Lua.lua_type(luaState, 1);
            if (r == (int)LUA_TYPE.LUA_TSTRING)
            {
                uint ll = 0;
                string v = Marshal.PtrToStringAnsi(Lua.lua_tolstring(luaState, -1, out ll));
                Lua.lua_settop(luaState, -3);
                return;
            }

            Lua.lua_pop(luaState, 1);

            //---------- SetEmptyCallback
            Lua.lua_pushstring(luaState, "SetEmptyCallback");
            Lua.lua_rawget(luaState, -2);
            // таблицу как параметр 
            Lua.lua_pushvalue(luaState, -2);
            Lua.lua_call(luaState, 1, 1);
            Lua.lua_pop(luaState, 1);
            //----------

            //----------
            Lua.lua_pushstring(luaState, "Size");
            Lua.lua_rawget(luaState, -2);
            Lua.lua_pushvalue(luaState, -2);
            Lua.lua_call(luaState, 1, 1);

            var size_table = Lua.lua_tonumber(luaState, -1);

            Lua.lua_pop(luaState, 1);
            //----------

            //----------
            Lua.lua_pushstring(luaState, "C");
            Lua.lua_rawget(luaState, -2);
            Lua.lua_pushvalue(luaState, -2);
            Lua.lua_pushinteger(luaState, 10);

            Lua.lua_call(luaState, 2, 1);

            var rr = Lua.lua_tonumber(luaState, -1);
            Lua.lua_pop(luaState, 1);
            //----------

            //----------
            Lua.lua_pushstring(luaState, "Close");
            Lua.lua_rawget(luaState, -2);
            Lua.lua_pushvalue(luaState, -2);
            Lua.lua_call(luaState, 1, 1);

            Lua.lua_pop(luaState, 1);
            //----------

        }

        [DllExport("luaopen_InQuikModule", CallingConvention = CallingConvention.Cdecl)]
        public static int InQuikModuleStartUp(IntPtr L)
        {
            Lua.lua_pushcclosure(L, forLua_OnStop, 0);
            Lua.lua_setfield(L, -10002, "OnStop");

            Lua.lua_pushcclosure(L, forLua_OnClose, 0);
            Lua.lua_setfield(L, -10002, "OnClose");

            Lua.lua_pushcclosure(L, forLua_Main, 0);
            Lua.lua_setfield(L, -10002, "main");

            return 0;
        }

        private static int _runServer = 0;
        static int forLua_OnClose(IntPtr L)
        {
            Interlocked.Exchange(ref _runServer, 1);
            return 0;
        }

        static int forLua_OnStop(IntPtr L)
        {
            Interlocked.Exchange(ref _runServer, 1);
            return 0;
        }

        static int forLua_Main(IntPtr L)
        {

            CreateDataSourceTick(L);

            while (_runServer == 0)
            {
                Thread.Sleep(100);
            }

            Interlocked.Exchange(ref _runServer, 0);
            return 0;
        }
    }
}
